HTTPS support for rApp Catalogue
[nonrtric.git] / test / common / testcase_common.sh
index f8ff19f..cef8188 100755 (executable)
 #  ============LICENSE_END=================================================
 #
 
-# This is a script that contains all the functions needed for auto test
-# Arg: local|remote|remote-remove [auto-clean] [--stop-at-error] [--ricsim-prefix <prefix> ] [ --env-file <environment-filename> ] [--use-local-image <app-nam> [<app-name>]*]
+# This is a script that contains all the common functions needed for auto test.
+# Specific test function are defined in scripts  XXXX_functions.sh
+
+
+# List of short names for all supported apps, including simulators etc
+APP_SHORT_NAMES="PA RICSIM SDNC CP ECS RC CBS CONSUL RC MRSTUB CR PRODSTUB"
+
+__print_args() {
+       echo "Args: remote|remote-remove --env-file <environment-filename> [release] [auto-clean] [--stop-at-error] "
+       echo "      [--ricsim-prefix <prefix> ] [--use-local-image <app-nam>+]  [--use-snapshot-image <app-nam>+]"
+       echo "      [--use-staging-image <app-nam>+] [--use-release-image <app-nam>+]"
+}
+
+if [ $# -eq 1 ] && [ "$1" == "help" ]; then
+
+       if [ ! -z "$TC_ONELINE_DESCR" ]; then
+               echo "Test script description:"
+               echo $TC_ONELINE_DESCR
+               echo ""
+       fi
+       __print_args
+       echo ""
+       echo "remote                -  Use images from remote repositories. Can be overridden for individual images using the '--use_xxx' flags"
+       echo "remote-remove         -  Same as 'remote' but will also try to pull fresh images from remote repositories"
+       echo "--env-file            -  The script will use the supplied file to read environment variables from"
+       echo "release               -  If this flag is given the script will use release version of the images"
+       echo "auto-clean            -  If the function 'auto_clean_containers' is present in the end of the test script then all containers will be stopped and removed. If 'auto-clean' is not given then the function has no effect."
+    echo "--stop-at-error       -  The script will stop when the first failed test or configuration"
+       echo "--ricsim-prefix       -  The a1 simulator will use the supplied string as container prefix instead of 'ricsim'"
+       echo "--use-local-image     -  The script will use local images for the supplied apps, space separated list of app short names"
+       echo "--use-snapshot-image  -  The script will use images from the nexus snapshot repo for the supplied apps, space separated list of app short names"
+       echo "--use-staging-image   -  The script will use images from the nexus staging repo for the supplied apps, space separated list of app short names"
+       echo "--use-release-image   -  The script will use images from the nexus release repo for the supplied apps, space separated list of app short names"
+       echo ""
+       echo "List of app short names supported: "$APP_SHORT_NAMES
+       exit 0
+fi
+
 
 
 # Create a test case id, ATC (Auto Test Case), from the name of the test case script.
@@ -80,15 +116,29 @@ AGENT_STAND_ALONE=0
 # Var to hold 'auto' in case containers shall be stopped when test case ends
 AUTO_CLEAN=""
 
-# Var to hold the app names to use local image for when running 'remote' or 'remote-remove'
+# Var to hold the app names to use local images for
 USE_LOCAL_IMAGES=""
 
-# List of available apps to override with local image
-AVAILABLE_LOCAL_IMAGES_OVERRIDE="PA ECS CP SDNC RICSIM"
+# Var to hold the app names to use remote snapshot images for
+USE_SNAPSHOT_IMAGES=""
+
+# Var to hold the app names to use remote staging images for
+USE_STAGING_IMAGES=""
+
+# Var to hold the app names to use remote release images for
+USE_RELEASE_IMAGES=""
+
+# List of available apps to override with local or remote staging/snapshot/release image
+AVAILABLE_IMAGES_OVERRIDE="PA ECS CP SDNC RICSIM RC"
 
 # Use this var (STOP_AT_ERROR=1 in the test script) for debugging/trouble shooting to take all logs and exit at first FAIL test case
 STOP_AT_ERROR=0
 
+# The default value "DEV" indicate that development image tags (SNAPSHOT) and nexus repos (nexus port 10002) are used.
+# The value "RELEASE" indicate that relase image tag and nexus repos (nexus port) are used
+# Applies only to images defined in the test-env files with image names and tags defined as XXXX_RELEASE
+IMAGE_CATEGORY="DEV"
+
 # Function to indent cmd output with one space
 indent1() { sed 's/^/ /'; }
 
@@ -128,6 +178,17 @@ echo "" > $HTTPLOG
 # Create a log dir for the test case
 mkdir -p $TESTLOGS/$ATC
 
+# Save create for current logs
+mkdir -p $TESTLOGS/$ATC/previous
+
+rm $TESTLOGS/$ATC/previous/*.log &> /dev/null
+rm $TESTLOGS/$ATC/previous/*.txt &> /dev/null
+rm $TESTLOGS/$ATC/previous/*.json &> /dev/null
+
+mv  $TESTLOGS/$ATC/*.log $TESTLOGS/$ATC/previous &> /dev/null
+mv  $TESTLOGS/$ATC/*.txt $TESTLOGS/$ATC/previous &> /dev/null
+mv  $TESTLOGS/$ATC/*.txt $TESTLOGS/$ATC/previous &> /dev/null
+
 # Clear the log dir for the test case
 rm $TESTLOGS/$ATC/*.log &> /dev/null
 rm $TESTLOGS/$ATC/*.txt &> /dev/null
@@ -148,6 +209,94 @@ RES_DEVIATION=0
 DEVIATION_FILE=".tmp_deviations"
 rm $DEVIATION_FILE &> /dev/null
 
+
+# Trap "command not found" and make the script fail
+trap_fnc() {
+
+       if [ $? -eq 127 ]; then
+               echo -e $RED"Function not found, setting script to FAIL"$ERED
+               ((RES_CONF_FAIL++))
+       fi
+}
+trap trap_fnc ERR
+
+# Counter for tests
+TEST_SEQUENCE_NR=1
+
+__log_test_start() {
+       TIMESTAMP=$(date "+%Y-%m-%d %H:%M:%S")
+       echo -e $BOLD"TEST $TEST_SEQUENCE_NR (${BASH_LINENO[1]}): ${FUNCNAME[1]}" $@ $EBOLD
+    echo "TEST $TEST_SEQUENCE_NR - ${TIMESTAMP}: (${BASH_LINENO[1]}): ${FUNCNAME[1]}" $@ >> $HTTPLOG
+       ((RES_TEST++))
+       ((TEST_SEQUENCE_NR++))
+}
+
+__log_test_fail_general() {
+       echo -e $RED" FAIL."$1 $ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_fail_status_code() {
+       echo -e $RED" FAIL. Exepected status "$1", got "$2 $3 $ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_fail_body() {
+       echo -e $RED" FAIL, returned body not correct"$ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_fail_not_supported() {
+       echo -e $RED" FAIL, function not supported"$ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_pass() {
+       if [ $# -gt 0 ]; then
+               echo $@
+       fi
+       ((RES_PASS++))
+       echo -e $GREEN" PASS"$EGREEN
+}
+
+#Counter for configurations
+CONF_SEQUENCE_NR=1
+__log_conf_start() {
+       TIMESTAMP=$(date "+%Y-%m-%d %H:%M:%S")
+       echo -e $BOLD"CONF $CONF_SEQUENCE_NR (${BASH_LINENO[1]}): "${FUNCNAME[1]} $@ $EBOLD
+       echo "CONF $CONF_SEQUENCE_NR - ${TIMESTAMP}: (${BASH_LINENO[1]}): "${FUNCNAME[1]} $@  >> $HTTPLOG
+       ((CONF_SEQUENCE_NR++))
+}
+
+__log_conf_fail_general() {
+       echo -e $RED" FAIL."$1 $ERED
+       ((RES_CONF_FAIL++))
+       __check_stop_at_error
+}
+
+__log_conf_fail_status_code() {
+       echo -e $RED" FAIL. Exepected status "$1", got "$2 $3 $ERED
+       ((RES_CONF_FAIL++))
+       __check_stop_at_error
+}
+
+__log_conf_fail_body() {
+       echo -e $RED" FAIL, returned body not correct"$ERED
+       ((RES_CONF_FAIL++))
+       __check_stop_at_error
+}
+
+__log_conf_ok() {
+       if [ $# -gt 0 ]; then
+               echo $@
+       fi
+       echo -e $GREEN" OK"$EGREEN
+}
+
 #Var for measuring execution time
 TCTEST_START=$SECONDS
 
@@ -166,12 +315,16 @@ echo "-----------------------------------      Test case setup      ------------
 
 START_ARG=$1
 paramerror=0
+paramerror_str=""
 if [ $# -lt 1 ]; then
        paramerror=1
 fi
 if [ $paramerror -eq 0 ]; then
-       if [ "$1" != "remote" ] && [ "$1" != "remote-remove" ] && [ "$1" != "local" ]; then
+       if [ "$1" != "remote" ] && [ "$1" != "remote-remove" ]; then
                paramerror=1
+               if [ -z "$paramerror_str" ]; then
+                       paramerror_str="First arg shall be 'remote' or 'remote-remove'"
+               fi
        else
                shift;
        fi
@@ -179,6 +332,14 @@ fi
 foundparm=0
 while [ $paramerror -eq 0 ] && [ $foundparm -eq 0 ]; do
        foundparm=1
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "release" ]; then
+                       IMAGE_CATEGORY="RELEASE"
+                       echo "Option set - Release image tags used for applicable images "
+                       shift;
+                       foundparm=0
+               fi
+       fi
        if [ $paramerror -eq 0 ]; then
                if [ "$1" == "auto-clean" ]; then
                        AUTO_CLEAN="auto"
@@ -201,6 +362,9 @@ while [ $paramerror -eq 0 ] && [ $foundparm -eq 0 ]; do
                        RIC_SIM_PREFIX=$1
                        if [ -z "$1" ]; then
                                paramerror=1
+                               if [ -z "$paramerror_str" ]; then
+                                       paramerror_str="No prefix found for flag: '--ricsim-prefix'"
+                               fi
                        else
                                echo "Option set - Overriding RIC_SIM_PREFIX with: "$1
                                shift;
@@ -214,6 +378,9 @@ while [ $paramerror -eq 0 ] && [ $foundparm -eq 0 ]; do
                        TEST_ENV_VAR_FILE=$1
                        if [ -z "$1" ]; then
                                paramerror=1
+                               if [ -z "$paramerror_str" ]; then
+                                       paramerror_str="No env file found for flag: '--env-file'"
+                               fi
                        else
                                echo "Option set - Reading test env from: "$1
                                shift;
@@ -227,16 +394,97 @@ while [ $paramerror -eq 0 ] && [ $foundparm -eq 0 ]; do
                        shift
                        while [ $# -gt 0 ] && [[ "$1" != "--"* ]]; do
                                USE_LOCAL_IMAGES=$USE_LOCAL_IMAGES" "$1
-                               if [[ "$AVAILABLE_LOCAL_IMAGES_OVERRIDE" != *"$1"* ]]; then
+                               if [[ "$AVAILABLE_IMAGES_OVERRIDE" != *"$1"* ]]; then
                                        paramerror=1
+                                       if [ -z "$paramerror_str" ]; then
+                                               paramerror_str="App name $1 is not available for local override for flag: '--use-local-image'"
+                                       fi
                                fi
                                shift;
                        done
                        foundparm=0
                        if [ -z "$USE_LOCAL_IMAGES" ]; then
                                paramerror=1
+                               if [ -z "$paramerror_str" ]; then
+                                       paramerror_str="No app name found for flag: '--use-local-image'"
+                               fi
+                       else
+                               echo "Option set - Overriding with local images for app(s):"$USE_LOCAL_IMAGES
+                       fi
+               fi
+       fi
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "--use-snapshot-image" ]; then
+                       USE_SNAPSHOT_IMAGES=""
+                       shift
+                       while [ $# -gt 0 ] && [[ "$1" != "--"* ]]; do
+                               USE_SNAPSHOT_IMAGES=$USE_SNAPSHOT_IMAGES" "$1
+                               if [[ "$AVAILABLE_IMAGES_OVERRIDE" != *"$1"* ]]; then
+                                       paramerror=1
+                                       if [ -z "$paramerror_str" ]; then
+                                               paramerror_str="App name $1 is not available for snapshot override for flag: '--use-snapshot-image'"
+                                       fi
+                               fi
+                               shift;
+                       done
+                       foundparm=0
+                       if [ -z "$USE_SNAPSHOT_IMAGES" ]; then
+                               paramerror=1
+                               if [ -z "$paramerror_str" ]; then
+                                       paramerror_str="No app name found for flag: '--use-snapshot-image'"
+                               fi
+                       else
+                               echo "Option set - Overriding with snapshot images for app(s):"$USE_SNAPSHOT_IMAGES
+                       fi
+               fi
+       fi
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "--use-staging-image" ]; then
+                       USE_STAGING_IMAGES=""
+                       shift
+                       while [ $# -gt 0 ] && [[ "$1" != "--"* ]]; do
+                               USE_STAGING_IMAGES=$USE_STAGING_IMAGES" "$1
+                               if [[ "$AVAILABLE_IMAGES_OVERRIDE" != *"$1"* ]]; then
+                                       paramerror=1
+                                       if [ -z "$paramerror_str" ]; then
+                                               paramerror_str="App name $1 is not available for staging override for flag: '--use-staging-image'"
+                                       fi
+                               fi
+                               shift;
+                       done
+                       foundparm=0
+                       if [ -z "$USE_STAGING_IMAGES" ]; then
+                               paramerror=1
+                               if [ -z "$paramerror_str" ]; then
+                                       paramerror_str="No app name found for flag: '--use-staging-image'"
+                               fi
+                       else
+                               echo "Option set - Overriding with staging images for app(s):"$USE_STAGING_IMAGES
+                       fi
+               fi
+       fi
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "--use-release-image" ]; then
+                       USE_RELEASE_IMAGES=""
+                       shift
+                       while [ $# -gt 0 ] && [[ "$1" != "--"* ]]; do
+                               USE_RELEASE_IMAGES=$USE_RELEASE_IMAGES" "$1
+                               if [[ "$AVAILABLE_IMAGES_OVERRIDE" != *"$1"* ]]; then
+                                       paramerror=1
+                                       if [ -z "$paramerror_str" ]; then
+                                               paramerror_str="App name $1 is not available for release override for flag: '--use-release-image'"
+                                       fi
+                               fi
+                               shift;
+                       done
+                       foundparm=0
+                       if [ -z "$USE_RELEASE_IMAGES" ]; then
+                               paramerror=1
+                               if [ -z "$paramerror_str" ]; then
+                                       paramerror_str="No app name found for flag: '--use-release-image'"
+                               fi
                        else
-                               echo "Option set - Override remote images for app(s):"$USE_LOCAL_IMAGES
+                               echo "Option set - Overriding with release images for app(s):"$USE_RELEASE_IMAGES
                        fi
                fi
        fi
@@ -246,10 +494,14 @@ echo ""
 #Still params left?
 if [ $paramerror -eq 0 ] && [ $# -gt 0 ]; then
        paramerror=1
+       if [ -z "$paramerror_str" ]; then
+               paramerror_str="Unknown parameter(s): "$@
+       fi
 fi
 
 if [ $paramerror -eq 1 ]; then
-       echo -e $RED"Expected arg: local|remote|remote-remove [auto-clean] [--stop-at-error] [--ricsim-prefix <prefix> ] [ --env-file <environment-filename> ] [--use-local-image <app-nam> [<app-name>]*]"$ERED
+       echo -e $RED"Incorrect arg list: "$paramerror_str$ERED
+       __print_args
        exit 1
 fi
 
@@ -257,6 +509,19 @@ fi
 if [ -f "$TEST_ENV_VAR_FILE" ]; then
        echo -e $BOLD"Sourcing env vars from: "$TEST_ENV_VAR_FILE$EBOLD
        . $TEST_ENV_VAR_FILE
+
+       if [ -z "$TEST_ENV_PROFILE" ] || [ -z "$SUPPORTED_PROFILES" ]; then
+               echo -e $YELLOW"This test case may not work with selected test env file. TEST_ENV_PROFILE is missing in test_env file or SUPPORTED_PROFILES is missing in test case file"$EYELLOW
+       else
+               if [[ "$SUPPORTED_PROFILES" == *"$TEST_ENV_PROFILE"* ]]; then
+                       echo -e $GREEN"Test case support the selected test env file"$EGREEN
+               else
+                       echo -e $RED"Test case does not support the selected test env file"$ERED
+                       echo "Profile: "$TEST_ENV_PROFILE"     Supported profiles: "$SUPPORTED_PROFILES
+                       echo -e $RED"Exiting...."$ERED
+                       exit 1
+               fi
+       fi
 else
        echo -e $RED"Selected env var file does not exist: "$TEST_ENV_VAR_FILE$ERED
        echo " Select one of following env var file matching the intended target of the test"
@@ -265,13 +530,23 @@ else
        exit 1
 fi
 
+if [ -z "$PROJECT_IMAGES_APP_NAMES" ]; then
+       echo -e $RED"Var PROJECT_IMAGES_APP_NAMES must be defined in: "$TEST_ENV_VAR_FILE$ERED$ERED
+       exit 1
+fi
+
+
 #Vars for A1 interface version and container count
 G1_A1_VERSION=""
 G2_A1_VERSION=""
 G3_A1_VERSION=""
+G4_A1_VERSION=""
+G5_A1_VERSION=""
 G1_COUNT=0
 G2_COUNT=0
 G3_COUNT=0
+G4_COUNT=0
+G5_COUNT=0
 
 # Vars to switch between http and https. Extra curl flag needed for https
 export RIC_SIM_HTTPX="http"
@@ -286,29 +561,34 @@ export MR_LOCAL_PORT=$MR_EXTERNAL_PORT #When agent is running outside the docker
 export CR_HTTPX="http"
 export CR_PORT=$CR_INTERNAL_PORT
 export CR_LOCAL_PORT=$CR_EXTERNAL_PORT #When CR is running outside the docker net
+export CR_PATH="$CR_HTTPX://$CR_APP_NAME:$CR_PORT$CR_APP_CALLBACK"
 
 export PROD_STUB_HTTPX="http"
 export PROD_STUB_PORT=$PROD_STUB_INTERNAL_PORT
-export PROD_STUB_LOCAL_PORT=$PROD_STUB_EXTERNAL_PORT #When CR is running outside the docker net
+export PROD_STUB_LOCAL_PORT=$PROD_STUB_EXTERNAL_PORT #When Prodstub is running outside the docker net
 export PROD_STUB_LOCALHOST=$PROD_STUB_HTTPX"://localhost:"$PROD_STUB_LOCAL_PORT
 
 export SDNC_HTTPX="http"
 export SDNC_PORT=$SDNC_INTERNAL_PORT
 export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_PORT #When agent is running outside the docker net
 
+export RAPP_CAT_HTTPX="http"
+export RAPP_CAT_PORT=$RAPP_CAT_INTERNAL_PORT
+export RAPP_CAT_LOCAL_PORT=$RAPP_CAT_EXTERNAL_PORT #When Rapp catalogue is running outside the docker net
+
 echo -e $BOLD"Checking configured image setting for this test case"$EBOLD
 
 #Temp var to check for image variable name errors
 IMAGE_ERR=0
 #Create a file with image info for later printing as a table
 image_list_file="./tmp/.image-list"
-echo -e " Container\tImage\ttag" > $image_list_file
+echo -e " Container\tImage\ttag\ttag-switch" > $image_list_file
 
 # Check if image env var is set and if so export the env var with image to use (used by docker compose files)
-# arg: <image name> <script start-arg> <target-variable-name> <image-variable-name> <image-tag-variable-name> <app-short-name>
-__check_image_var() {
+# arg: <image name> <target-variable-name> <image-variable-name> <image-tag-variable-name> <tag-suffix> <app-short-name>
+__check_and_create_image_var() {
        if [ $# -ne 6 ]; then
-               echo "Expected arg: <image name> <script start-arg> <target-variable-name> <image-variable-name> <image-tag-variable-name> <app-short-name>"
+               echo "Expected arg: <image name> <target-variable-name> <image-variable-name> <image-tag-variable-name> <tag-suffix> <app-short-name>"
                ((IMAGE_ERR++))
                return
        fi
@@ -320,42 +600,50 @@ __check_image_var() {
        fi
        tmp=${1}"\t"
        #Create var from the input var names
-       image="${!4}"
-       tag="${!5}"
+       image="${!3}"
+       tmptag=$4"_"$5
+       tag="${!tmptag}"
 
        if [ -z $image ]; then
-               echo -e $RED"\$"$4" not set in $TEST_ENV_VAR_FILE"$ERED
-               ((IMAGE_ERR++))
+               echo -e $RED"\$"$3" not set in $TEST_ENV_VAR_FILE"$ERED
+               ((IMAGE_ERR++))
                echo ""
                tmp=$tmp"<no-image>\t"
        else
+               #Add repo depending on image type
+               if [ "$5" == "REMOTE_RELEASE" ]; then
+                       image=$NEXUS_RELEASE_REPO$image
+               fi
+               if [ "$5" == "REMOTE" ]; then
+                       image=$NEXUS_STAGING_REPO$image
+               fi
+               if [ "$5" == "REMOTE_SNAPSHOT" ]; then
+                       image=$NEXUS_SNAPSHOT_REPO$image
+               fi
+               if [ "$5" == "REMOTE_PROXY" ]; then
+                       image=$NEXUS_PROXY_REPO$image
+               fi
+               if [ "$5" == "REMOTE_RELEASE_ONAP" ]; then
+                       image=$NEXUS_RELEASE_REPO_ONAP$image
+               fi
+               if [ "$5" == "REMOTE_RELEASE_ORAN" ]; then
+                       image=$NEXUS_RELEASE_REPO_ORAN$image
+               fi
+               #No nexus repo added for local images, tag: LOCAL
                tmp=$tmp$image"\t"
        fi
        if [ -z $tag ]; then
-               echo -e $RED"\$"$5" not set in $TEST_ENV_VAR_FILE"$ERED
-               ((IMAGE_ERR++))
+               echo -e $RED"\$"$tmptag" not set in $TEST_ENV_VAR_FILE"$ERED
+               ((IMAGE_ERR++))
                echo ""
                tmp=$tmp"<no-tag>\t"
        else
                tmp=$tmp$tag
        fi
+       tmp=$tmp"\t"$5
        echo -e "$tmp" >> $image_list_file
        #Export the env var
-       export "${3}"=$image":"$tag
-
-       #echo " Configured image for ${1} (script start arg=${2}): "$image":"$tag
-}
-
-
-#Check if app local image shall override remote image
-# Possible IDs for local image override: PA, CP, SDNC, RICSIM, ECS
-__check_image_local_override() {
-       for im in $USE_LOCAL_IMAGES; do
-               if [ "$1" == "$im" ]; then
-                       return 1
-               fi
-       done
-       return 0
+       export "${2}"=$image":"$tag
 }
 
 # Check if app uses image included in this test run
@@ -370,84 +658,142 @@ __check_included_image() {
        return 1
 }
 
-# Check that image env setting are available
-echo ""
-
-if [ $START_ARG == "local" ]; then
-
-       #Local agent image
-       __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG" PA
+__check_image_local_override() {
+       for im in $USE_LOCAL_IMAGES; do
+               if [ "$1" == "$im" ]; then
+                       return 1
+               fi
+       done
+       return 0
+}
 
-       #Local Control Panel image
-       __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG" CP
+# Check if app uses image override
+# Returns the image/tag suffix LOCAL for local image or REMOTE/REMOTE_RELEASE/REMOTE_SNAPSHOT for staging/release/snapshot image
+__check_image_override() {
 
-       #Local SNDC image
-       __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG" SDNC
+       for im in $ORAN_IMAGES_APP_NAMES; do
+               if [ "$1" == "$im" ]; then
+                       echo "REMOTE_RELEASE_ORAN"
+                       return 0
+               fi
+       done
 
-       #Local ric sim image
-       __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG" RICSIM
+       for im in $ONAP_IMAGES_APP_NAMES; do
+               if [ "$1" == "$im" ]; then
+                       echo "REMOTE_RELEASE_ONAP"
+                       return 0
+               fi
+       done
 
-elif [ $START_ARG == "remote" ] || [ $START_ARG == "remote-remove" ]; then
+       found=0
+       for im in $PROJECT_IMAGES_APP_NAMES; do
+               if [ "$1" == "$im" ]; then
+                       found=1
+               fi
+       done
 
-       __check_image_local_override 'PA'
-       if [ $? -eq 0 ]; then
-               #Remote agent image
-               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_REMOTE_IMAGE" "POLICY_AGENT_REMOTE_IMAGE_TAG" PA
-       else
-               #Local agent image
-               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG" PA
+       if [ $found -eq 0 ]; then
+               echo "REMOTE_PROXY"
+               return 0
        fi
 
-       __check_image_local_override 'CP'
-       if [ $? -eq 0 ]; then
-               #Remote Control Panel image
-               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE_TAG" CP
-       else
-               #Local Control Panel image
-               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG" CP
+       suffix=""
+       if [ $IMAGE_CATEGORY == "RELEASE" ]; then
+               suffix="REMOTE_RELEASE"
        fi
-
-       __check_image_local_override 'SDNC'
-       if [ $? -eq 0 ]; then
-               #Remote SDNC image
-               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE_TAG" SDNC
-       else
-               #Local SNDC image
-               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG" SDNC
+       if [ $IMAGE_CATEGORY == "DEV" ]; then
+               suffix="REMOTE"
        fi
-
-       __check_image_local_override 'RICSIM'
-       if [ $? -eq 0 ]; then
-               #Remote ric sim image
-               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_REMOTE_IMAGE" "RIC_SIM_REMOTE_IMAGE_TAG" RICSIM
-       else
-               #Local ric sim image
-               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG" RICSIM
+       CTR=0
+       for im in $USE_STAGING_IMAGES; do
+               if [ "$1" == "$im" ]; then
+                       suffix="REMOTE"
+                       ((CTR++))
+               fi
+       done
+       for im in $USE_RELEASE_IMAGES; do
+               if [ "$1" == "$im" ]; then
+                       suffix="REMOTE_RELEASE"
+                       ((CTR++))
+               fi
+       done
+       for im in $USE_SNAPSHOT_IMAGES; do
+               if [ "$1" == "$im" ]; then
+                       suffix="REMOTE_SNAPSHOT"
+                       ((CTR++))
+               fi
+       done
+       for im in $USE_LOCAL_IMAGES; do
+               if [ "$1" == "$im" ]; then
+                       suffix="LOCAL"
+                       ((CTR++))
+               fi
+       done
+       echo $suffix
+       if [ $CTR -gt 1 ]; then
+               exit 1
        fi
+       return 0
+}
 
-       __check_image_local_override 'ECS'
-       if [ $? -eq 0 ]; then
-               #Remote ecs image
-               __check_image_var " ECS" $START_ARG "ECS_IMAGE" "ECS_REMOTE_IMAGE" "ECS_REMOTE_IMAGE_TAG" ECS
-       else
-               #Local ecs image
-               __check_image_var " ECS" $START_ARG "ECS_IMAGE" "ECS_LOCAL_IMAGE" "ECS_LOCAL_IMAGE_TAG" ECS
-       fi
+# Check that image env setting are available
+echo ""
 
-else
-       #Should never get here....
-       echo "Unknow args: "$@
-       exit 1
+#Agent image
+IMAGE_SUFFIX=$(__check_image_override 'PA')
+if [ $? -ne 0 ]; then
+       echo -e $RED"Image setting from cmd line not consistent for PA."$ERED
+       ((IMAGE_ERR++))
 fi
+__check_and_create_image_var " Policy Agent" "POLICY_AGENT_IMAGE" "POLICY_AGENT_IMAGE_BASE" "POLICY_AGENT_IMAGE_TAG" $IMAGE_SUFFIX PA
 
+#Remote Control Panel image
+IMAGE_SUFFIX=$(__check_image_override 'CP')
+if [ $? -ne 0 ]; then
+       echo -e $RED"Image setting from cmd line not consistent for CP."$ERED
+       ((IMAGE_ERR++))
+fi
+__check_and_create_image_var " Control Panel" "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_IMAGE_BASE" "CONTROL_PANEL_IMAGE_TAG" $IMAGE_SUFFIX CP
+
+#Remote SDNC image
+IMAGE_SUFFIX=$(__check_image_override 'SDNC')
+if [ $? -ne 0 ]; then
+       echo -e $RED"Image setting from cmd line not consistent for SDNC."$ERED
+       ((IMAGE_ERR++))
+fi
+__check_and_create_image_var " SDNC A1 Controller" "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_IMAGE_BASE" "SDNC_A1_CONTROLLER_IMAGE_TAG" $IMAGE_SUFFIX SDNC
+
+#Remote ric sim image
+IMAGE_SUFFIX=$(__check_image_override 'RICSIM')
+if [ $? -ne 0 ]; then
+       echo -e $RED"Image setting from cmd line not consistent for RICSIM."$ERED
+       ((IMAGE_ERR++))
+fi
+__check_and_create_image_var " RIC Simulator" "RIC_SIM_IMAGE" "RIC_SIM_IMAGE_BASE" "RIC_SIM_IMAGE_TAG" $IMAGE_SUFFIX RICSIM
+
+#Remote ecs image
+IMAGE_SUFFIX=$(__check_image_override 'ECS')
+if [ $? -ne 0 ]; then
+       echo -e $RED"Image setting from cmd line not consistent for ECS."$EREDs
+       ((IMAGE_ERR++))
+fi
+__check_and_create_image_var " ECS" "ECS_IMAGE" "ECS_IMAGE_BASE" "ECS_IMAGE_TAG" $IMAGE_SUFFIX ECS
+
+#Remote rc image
+IMAGE_SUFFIX=$(__check_image_override 'RC')
+if [ $? -ne 0 ]; then
+       echo -e $RED"Image setting from cmd line not consistent for RC."$ERED
+       ((IMAGE_ERR++))
+fi
+__check_and_create_image_var " RC" "RAPP_CAT_IMAGE" "RAPP_CAT_IMAGE_BASE" "RAPP_CAT_IMAGE_TAG" $IMAGE_SUFFIX RC
 
 # These images are not built as part of this project official images, just check that env vars are set correctly
-__check_image_var " Message Router" $START_ARG "MRSTUB_IMAGE" "MRSTUB_LOCAL_IMAGE" "MRSTUB_LOCAL_IMAGE_TAG" MR
-__check_image_var " Callback Receiver" $START_ARG "CR_IMAGE" "CR_LOCAL_IMAGE" "CR_LOCAL_IMAGE_TAG" CR
-__check_image_var " Producer stub" $START_ARG "PROD_STUB_IMAGE" "PROD_STUB_LOCAL_IMAGE" "PROD_STUB_LOCAL_IMAGE_TAG" PRODSTUB
-__check_image_var " Consul" $START_ARG "CONSUL_IMAGE" "CONSUL_REMOTE_IMAGE" "CONSUL_REMOTE_IMAGE_TAG" CONSUL
-__check_image_var " CBS" $START_ARG "CBS_IMAGE" "CBS_REMOTE_IMAGE" "CBS_REMOTE_IMAGE_TAG" CBS
-__check_image_var " SDNC DB" $START_ARG "SDNC_DB_IMAGE" "SDNC_DB_REMOTE_IMAGE" "SDNC_DB_REMOTE_IMAGE_TAG" SDNC #Uses sdnc app name
+__check_and_create_image_var " Message Router"    "MRSTUB_IMAGE"    "MRSTUB_IMAGE_BASE"    "MRSTUB_IMAGE_TAG"    LOCAL               MR
+__check_and_create_image_var " Callback Receiver" "CR_IMAGE"        "CR_IMAGE_BASE"        "CR_IMAGE_TAG"        LOCAL               CR
+__check_and_create_image_var " Producer stub"     "PROD_STUB_IMAGE" "PROD_STUB_IMAGE_BASE" "PROD_STUB_IMAGE_TAG" LOCAL               PRODSTUB
+__check_and_create_image_var " Consul"            "CONSUL_IMAGE"    "CONSUL_IMAGE_BASE"    "CONSUL_IMAGE_TAG"    REMOTE_PROXY        CONSUL
+__check_and_create_image_var " CBS"               "CBS_IMAGE"       "CBS_IMAGE_BASE"       "CBS_IMAGE_TAG"       REMOTE_RELEASE_ONAP CBS
+__check_and_create_image_var " SDNC DB"           "SDNC_DB_IMAGE"   "SDNC_DB_IMAGE_BASE"   "SDNC_DB_IMAGE_TAG"   REMOTE_PROXY        SDNC #Uses sdnc app name
 
 #Errors in image setting - exit
 if [ $IMAGE_ERR -ne 0 ]; then
@@ -527,35 +873,52 @@ __check_and_pull_image() {
                                fi
                        fi
                        echo -e "  Attempt to stop and remove container(s), if running - "$GREEN"stopped removed"$EGREEN
-                       echo -ne "  Removing image - ${SAMELINE}"
-                       tmp="$(docker images -q ${4})" &> /dev/null
-                       if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
-                               docker rmi --force $4 &> ./tmp/.dockererr
-                               if [ $? -ne 0 ]; then
-                                       ((IMAGE_ERR++))
-                                       echo ""
-                                       echo -e $RED"  Image could not be removed - try manual removal of the image"$ERED
-                                       cat ./tmp/.dockererr
-                                       return 1
-                               fi
-                               echo -e "  Removing image - "$GREEN"removed"$EGREEN
-                       else
-                               echo -e "  Removing image - "$GREEN"image not in repository"$EGREEN
-                       fi
+                       echo -ne "  Removing image - ${SAMELINE}"
+                       tmp="$(docker images -q ${4})" &> /dev/null
+                       if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
+                       #       docker rmi --force $4 &> ./tmp/.dockererr
+                       #       if [ $? -ne 0 ]; then
+                       #               ((IMAGE_ERR++))
+                       #               echo ""
+                       #               echo -e $RED"  Image could not be removed - try manual removal of the image"$ERED
+                       #               cat ./tmp/.dockererr
+                       #               return 1
+                       #       fi
+                       #       echo -e "  Removing image - "$GREEN"removed"$EGREEN
+                       else
+                       #       echo -e "  Removing image - "$GREEN"image not in repository"$EGREEN
+                       fi
                        tmp_im=""
                fi
                if [ -z "$tmp_im" ]; then
                        echo -ne "  Pulling image${SAMELINE}"
-                       docker pull $4  &> ./tmp/.dockererr
-                       tmp_im=$(docker images ${4} | grep -v REPOSITORY)
-                       if [ -z "$tmp_im" ]; then
+                       # docker pull $4        &> ./tmp/.dockererr
+                       # tmp_im=$(docker images ${4} | grep -v REPOSITORY)
+                       # if [ -z "$tmp_im" ]; then
+                       #       echo ""
+                       #       echo -e "  Pulling image -$RED could not be pulled"$ERED
+                       #       ((IMAGE_ERR++))
+                       #       cat ./tmp/.dockererr
+                       #       return 1
+                       # fi
+                       # echo -e "  Pulling image -$GREEN Pulled $EGREEN"
+                       out=$(docker pull $4)
+                       if [ $? -ne 0 ]; then
                                echo ""
                                echo -e "  Pulling image -$RED could not be pulled"$ERED
                                ((IMAGE_ERR++))
-                               cat ./tmp/.dockererr
+                               echo $out > ./tmp/.dockererr
+                               echo $out
                                return 1
                        fi
-                       echo -e "  Pulling image -$GREEN Pulled $EGREEN"
+                       echo $out > ./tmp/.dockererr
+                       if [[ $out == *"up to date"* ]]; then
+                               echo -e "  Pulling image -$GREEN Image is up to date $EGREEN"
+                       elif [[ $out == *"Downloaded newer image"* ]]; then
+                               echo -e "  Pulling image -$GREEN Newer image pulled $EGREEN"
+                       else
+                               echo -e "  Pulling image -$GREEN Pulled $EGREEN"
+                       fi
                else
                        echo -e "  Pulling image -$GREEN OK $EGREEN(exists in local repository)"
                fi
@@ -602,6 +965,18 @@ else
        echo -e $YELLOW" Excluding Non-RT RIC Control Panel image from image check/pull"$EYELLOW
 fi
 
+__check_included_image 'RC'
+if [ $? -eq 0 ]; then
+       START_ARG_MOD=$START_ARG
+       __check_image_local_override 'RC'
+       if [ $? -eq 1 ]; then
+               START_ARG_MOD="local"
+       fi
+       app="RAPP Catalogue"; __check_and_pull_image $START_ARG_MOD "$app" $RAPP_CAT_APP_NAME $RAPP_CAT_IMAGE
+else
+       echo -e $YELLOW" Excluding RAPP Catalogue image from image check/pull"$EYELLOW
+fi
+
 __check_included_image 'RICSIM'
 if [ $? -eq 0 ]; then
        START_ARG_MOD=$START_ARG
@@ -648,6 +1023,10 @@ if [ $IMAGE_ERR -ne 0 ]; then
        echo "#################################################################################################"
        echo -e $RED"One or more images could not be pulled or containers using the images could not be stopped/removed"$ERED
        echo -e $RED"Or local image, overriding remote image, does not exist"$ERED
+       if [ $IMAGE_CATEGORY == "DEV" ]; then
+               echo -e $RED"Note that SNAPSHOT images may be purged from nexus after a certain period."$ERED
+               echo -e $RED"In that case, switch to use a released image instead."$ERED
+       fi
        echo "#################################################################################################"
        echo ""
        exit 1
@@ -662,14 +1041,16 @@ __check_included_image 'MR'
 if [ $? -eq 0 ]; then
        cd $curdir
        cd ../mrstub
-       echo " Building mrstub image: $MRSTUB_LOCAL_IMAGE:$MRSTUB_LOCAL_IMAGE_TAG"
-       docker build -t $MRSTUB_LOCAL_IMAGE . &> .dockererr
+       echo " Building mrstub image: $MRSTUB_IMAGE:$MRSTUB_IMAGE_TAG_LOCAL"
+       docker build  --build-arg NEXUS_PROXY_REPO=$NEXUS_PROXY_REPO -t $MRSTUB_IMAGE . &> .dockererr
        if [ $? -eq 0 ]; then
                echo -e  $GREEN" Build Ok"$EGREEN
        else
                echo -e $RED" Build Failed"$ERED
                ((RES_CONF_FAIL++))
                cat .dockererr
+               echo -e $RED"Exiting...."$ERED
+               exit 1
        fi
        cd $curdir
 else
@@ -679,14 +1060,16 @@ fi
 __check_included_image 'CR'
 if [ $? -eq 0 ]; then
        cd ../cr
-       echo " Building Callback Receiver image: $CR_LOCAL_IMAGE:$CR_IMAGE_TAG"
-       docker build -t $CR_LOCAL_IMAGE . &> .dockererr
+       echo " Building Callback Receiver image: $CR_IMAGE:$CR_IMAGE_TAG_LOCAL"
+       docker build  --build-arg NEXUS_PROXY_REPO=$NEXUS_PROXY_REPO -t $CR_IMAGE . &> .dockererr
        if [ $? -eq 0 ]; then
                echo -e  $GREEN" Build Ok"$EGREEN
        else
                echo -e $RED" Build Failed"$ERED
                ((RES_CONF_FAIL++))
                cat .dockererr
+               echo -e $RED"Exiting...."$ERED
+               exit 1
        fi
        cd $curdir
 else
@@ -696,14 +1079,16 @@ fi
 __check_included_image 'PRODSTUB'
 if [ $? -eq 0 ]; then
        cd ../prodstub
-       echo " Building Producer stub image: $PROD_STUB_LOCAL_IMAGE:$PROD_STUB_LOCAL_IMAGE_TAG"
-       docker build -t $PROD_STUB_LOCAL_IMAGE . &> .dockererr
+       echo " Building Producer stub image: $PROD_STUB_IMAGE:$PROD_STUB_IMAGE_TAG_LOCAL"
+       docker build  --build-arg NEXUS_PROXY_REPO=$NEXUS_PROXY_REPO -t $PROD_STUB_IMAGE . &> .dockererr
        if [ $? -eq 0 ]; then
                echo -e  $GREEN" Build Ok"$EGREEN
        else
                echo -e $RED" Build Failed"$ERED
                ((RES_CONF_FAIL++))
                cat .dockererr
+               echo -e $RED"Exiting...."$ERED
+               exit 1
        fi
        cd $curdir
 else
@@ -734,6 +1119,10 @@ __check_included_image 'RICSIM'
 if [ $? -eq 0 ]; then
        echo -e " RIC Simulator\t$(docker images --format $format_string $RIC_SIM_IMAGE)" >>   $docker_tmp_file
 fi
+__check_included_image 'RC'
+if [ $? -eq 0 ]; then
+       echo -e " RAPP Catalogue\t$(docker images --format $format_string $RAPP_CAT_IMAGE)" >>   $docker_tmp_file
+fi
 __check_included_image 'MR'
 if [ $? -eq 0 ]; then
        echo -e " Message Router\t$(docker images --format $format_string $MRSTUB_IMAGE)" >>   $docker_tmp_file
@@ -744,7 +1133,7 @@ if [ $? -eq 0 ]; then
 fi
 __check_included_image 'PRODSTUB'
 if [ $? -eq 0 ]; then
-       echo -e " Produccer stub\t$(docker images --format $format_string $PROD_STUB_IMAGE)" >>   $docker_tmp_file
+       echo -e " Producer stub\t$(docker images --format $format_string $PROD_STUB_IMAGE)" >>   $docker_tmp_file
 fi
 __check_included_image 'CONSUL'
 if [ $? -eq 0 ]; then
@@ -783,6 +1172,7 @@ print_result() {
        echo "-------------------------------------------------------------------------------------------------"
        echo "-- Description: "$TC_ONELINE_DESCR
        echo "-- Execution time: " $duration " seconds"
+       echo "-- Used env file: "$TEST_ENV_VAR_FILE
        echo "-------------------------------------------------------------------------------------------------"
        echo "-------------------------------------     RESULTS"
        echo ""
@@ -968,6 +1358,7 @@ clean_containers() {
 
        CONTAINTER_NAMES=("Policy Agent           " $(__check_app_name $POLICY_AGENT_APP_NAME)\
                                          "ECS                    " $(__check_app_name $ECS_APP_NAME)\
+                                         "RAPP Catalogue         " $(__check_app_name $RAPP_CAT_APP_NAME)\
                                          "Non-RT RIC Simulator(s)" $(__check_app_name $RIC_SIM_PREFIX)\
                                          "Message Router         " $(__check_app_name $MR_APP_NAME)\
                                          "Callback Receiver      " $(__check_app_name $CR_APP_NAME)\
@@ -1031,7 +1422,8 @@ clean_containers() {
        if [ $? -eq 0 ]; then
                if [ $CONTRS -ne 0 ]; then
                        echo -e $RED"Containers running, may cause distubance to the test case"$ERED
-                       docker ps -a
+                       docker ps -a | indent1
+                       echo ""
                fi
        fi
 }
@@ -1077,6 +1469,7 @@ __print_err() {
        if [ $# -gt 1 ]; then
                echo -e $RED" Got: "${FUNCNAME[1]} ${@:2} $ERED
        fi
+       ((RES_CONF_FAIL++))
 }
 
 
@@ -1150,7 +1543,8 @@ __check_container_start() {
                        ((RES_CONF_FAIL++))
                        echo ""
                        echo -e $RED" Container $BOLD${appname}$EBOLD could not be started"$ERED
-                       return 1
+                       echo -e $RED" Stopping script..."$ERED
+                       exit 1
                fi
                if [ $localport -eq 0 ]; then
                        while [ $localport -eq 0 ]; do
@@ -1185,7 +1579,7 @@ __check_container_start() {
                else
                        TS_TMP=$SECONDS
                        while [ $(($TS_TMP+$i)) -gt $SECONDS ]; do
-                               echo -ne " Waiting for container ${appname} service status...retrying in $(($TS_TMP+$i-$SECONDS)) seconds   ${SAMELINE}"
+                               echo -ne " Waiting for container ${appname} service status...$(($SECONDS-$TSTART)) seconds, retrying in $(($TS_TMP+$i-$SECONDS)) seconds   ${SAMELINE}"
                                sleep 1
                        done
                fi
@@ -1193,7 +1587,7 @@ __check_container_start() {
 
        if [ "$pa_st" = "false"  ]; then
                ((RES_CONF_FAIL++))
-               echo -e $RED" Container ${appname} did not respond to service status"$ERED
+               echo -e $RED" Container ${appname} did not respond to service status in $(($SECONDS-$TSTART)) seconds"$ERED
                return 0
        fi
 
@@ -1224,6 +1618,8 @@ __start_container() {
                if [ $? -ne 0 ]; then
                        echo -e $RED"Problem to launch container(s) with docker-compose"$ERED
                        cat .dockererr
+                       echo -e $RED"Stopping script...."$ERED
+                       exit 1
                fi
        elif [ "$2" == "STANDALONE" ]; then
                echo "Skipping docker-compose"
@@ -1232,6 +1628,8 @@ __start_container() {
                if [ $? -ne 0 ]; then
                        echo -e $RED"Problem to launch container(s) with docker-compose"$ERED
                        cat .dockererr
+                       echo -e $RED"Stopping script...."$ERED
+                       exit 1
                fi
        fi
        app_prefix=""
@@ -1442,7 +1840,8 @@ start_consul_cbs() {
 ###########################
 
 use_simulator_http() {
-       echo -e "Using $BOLD http $EBOLD towards the simulators"
+       echo -e $BOLD"RICSIM protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards the simulators"
        export RIC_SIM_HTTPX="http"
        export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
        export RIC_SIM_PORT=$RIC_SIM_INTERNAL_PORT
@@ -1450,16 +1849,17 @@ use_simulator_http() {
 }
 
 use_simulator_https() {
-       echo -e "Using $BOLD https $EBOLD towards the simulators"
+       echo -e $BOLD"RICSIM protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards the simulators"
        export RIC_SIM_HTTPX="https"
        export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
        export RIC_SIM_PORT=$RIC_SIM_INTERNAL_SECURE_PORT
        echo ""
 }
 
-# Start one group (ricsim_g1, ricsim_g2 or ricsim_g3) with a number of RIC Simulators using a given A interface
+# Start one group (ricsim_g1, ricsim_g2 .. ricsim_g5) with a number of RIC Simulators using a given A interface
 # 'ricsim' may be set on command line to other prefix
-# args:  ricsim_g1|ricsim_g2|ricsim_g3 <count> <interface-id>
+# args:  ricsim_g1|ricsim_g2|ricsim_g3|ricsim_g4|ricsim_g5 <count> <interface-id>
 # (Function for test scripts)
 start_ric_simulators() {
 
@@ -1475,10 +1875,12 @@ start_ric_simulators() {
        RIC1=$RIC_SIM_PREFIX"_g1"
        RIC2=$RIC_SIM_PREFIX"_g2"
        RIC3=$RIC_SIM_PREFIX"_g3"
+       RIC4=$RIC_SIM_PREFIX"_g4"
+       RIC5=$RIC_SIM_PREFIX"_g5"
 
        if [ $# != 3 ]; then
                ((RES_CONF_FAIL++))
-       __print_err "need three args,  $RIC1|$RIC2|$RIC3 <count> <interface-id>" $@
+       __print_err "need three args,  $RIC1|$RIC2|$RIC3|$RIC4|$RIC5 <count> <interface-id>" $@
                exit 1
        fi
        echo " $2 simulators using basename: $1 on interface: $3"
@@ -1492,9 +1894,15 @@ start_ric_simulators() {
        elif [ $1 == "$RIC3" ]; then
                G3_COUNT=$2
                G3_A1_VERSION=$3
+       elif [ $1 == "$RIC4" ]; then
+               G4_COUNT=$2
+               G4_A1_VERSION=$3
+       elif [ $1 == "$RIC5" ]; then
+               G5_COUNT=$2
+               G5_A1_VERSION=$3
        else
                ((RES_CONF_FAIL++))
-       __print_err "need three args, $RIC1|$RIC2|$RIC3 <count> <interface-id>" $@
+       __print_err "need three args, $RIC1|$RIC2|$RIC3|$RIC4|$RIC5 <count> <interface-id>" $@
                exit 1
        fi
 
@@ -1504,8 +1912,10 @@ start_ric_simulators() {
        export G1_A1_VERSION
        export G2_A1_VERSION
        export G3_A1_VERSION
+       export G4_A1_VERSION
+       export G5_A1_VERSION
 
-       docker_args="--scale g1=$G1_COUNT --scale g2=$G2_COUNT --scale g3=$G3_COUNT"
+       docker_args="--scale g1=$G1_COUNT --scale g2=$G2_COUNT --scale g3=$G3_COUNT --scale g4=$G4_COUNT --scale g5=$G5_COUNT"
        app_data=""
        cntr=1
        while [ $cntr -le $2 ]; do
@@ -1538,6 +1948,44 @@ start_control_panel() {
 
 }
 
+###########################
+### RAPP Catalogue
+###########################
+
+# Start the RAPP Catalogue container
+# args: -
+# (Function for test scripts)
+start_rapp_catalogue() {
+
+       echo -e $BOLD"Starting RAPP Catalogue"$EBOLD
+
+       __check_included_image 'RC'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The RAPP Catalogue image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"The RAPP Catalogue will not be started"$ERED
+               exit
+       fi
+       __start_container rapp_catalogue NODOCKERARGS $RAPP_CAT_APP_NAME $RAPP_CAT_EXTERNAL_PORT "/services" "http"
+}
+
+use_rapp_catalogue_http() {
+       echo -e $BOLD"RAPP Catalogue protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards the RAPP Catalogue"
+       export RAPP_CAT_HTTPX="http"
+       export RAPP_CAT_PORT=$RAPP_CAT_INTERNAL_PORT
+       export RAPP_CAT_LOCAL_PORT=$RAPP_CAT_EXTERNAL_PORT
+       echo ""
+}
+
+use_rapp_catalogue_https() {
+       echo -e $BOLD"RAPP Catalogue protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards the RAPP Catalogue"
+       export RAPP_CAT_HTTPX="https"
+       export RAPP_CAT_PORT=$RAPP_CAT_INTERNAL_PORT
+       export RAPP_CAT_LOCAL_PORT=$RAPP_CAT_EXTERNAL_PORT
+       echo ""
+}
+
 ##################
 ### SDNC functions
 ##################
@@ -1561,7 +2009,8 @@ start_sdnc() {
 }
 
 use_sdnc_http() {
-       echo -e "Using $BOLD http $EBOLD towards SDNC"
+       echo -e $BOLD"SDNC protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards SDNC"
        export SDNC_HTTPX="http"
        export SDNC_PORT=$SDNC_INTERNAL_PORT
        export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_PORT
@@ -1569,7 +2018,8 @@ use_sdnc_http() {
 }
 
 use_sdnc_https() {
-       echo -e "Using $BOLD https $EBOLD towards SDNC"
+       echo -e $BOLD"SDNC protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards SDNC"
        export SDNC_HTTPX="https"
        export SDNC_PORT=$SDNC_INTERNAL_SECURE_PORT
        export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_SECURE_PORT
@@ -1597,7 +2047,8 @@ start_mr() {
 }
 
 use_mr_http() {
-       echo -e "Using $BOLD http $EBOLD towards MR"
+       echo -e $BOLD"MR protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards MR"
        export MR_HTTPX="http"
        export MR_PORT=$MR_INTERNAL_PORT
        export MR_LOCAL_PORT=$MR_EXTERNAL_PORT
@@ -1605,7 +2056,8 @@ use_mr_http() {
 }
 
 use_mr_https() {
-       echo -e "Using $BOLD https $EBOLD towards MR"
+       echo -e $BOLD"MR protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards MR"
        export MR_HTTPX="https"
        export MR_PORT=$MR_INTERNAL_SECURE_PORT
        export MR_LOCAL_PORT=$MR_EXTERNAL_SECURE_PORT
@@ -1634,18 +2086,22 @@ start_cr() {
 }
 
 use_cr_http() {
-       echo -e "Using $BOLD http $EBOLD towards CR"
+       echo -e $BOLD"CR protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards CR"
        export CR_HTTPX="http"
        export CR_PORT=$CR_INTERNAL_PORT
        export CR_LOCAL_PORT=$CR_EXTERNAL_PORT
+       export CR_PATH="$CR_HTTPX://$CR_APP_NAME:$CR_PORT$CR_APP_CALLBACK"
        echo ""
 }
 
 use_cr_https() {
-       echo -e "Using $BOLD https $EBOLD towards CR"
+       echo -e $BOLD"CR protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards CR"
        export CR_HTTPX="https"
        export CR_PORT=$CR_INTERNAL_SECURE_PORT
        export CR_LOCAL_PORT=$CR_EXTERNAL_SECURE_PORT
+       export CR_PATH="$CR_HTTPX://$CR_APP_NAME:$CR_PORT$CR_APP_CALLBACK"
        echo ""
 }
 
@@ -1670,7 +2126,8 @@ start_prod_stub() {
 }
 
 use_prod_stub_http() {
-       echo -e "Using $BOLD http $EBOLD towards Producer stub"
+       echo -e $BOLD"Producer stub protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards Producer stub"
        export PROD_STUB_HTTPX="http"
        export PROD_STUB_PORT=$PROD_STUB_INTERNAL_PORT
        export PROD_STUB_LOCAL_PORT=$PROD_STUB_EXTERNAL_PORT
@@ -1679,7 +2136,8 @@ use_prod_stub_http() {
 }
 
 use_prod_stub_https() {
-       echo -e "Using $BOLD https $EBOLD towards Producer stub"
+       echo -e $BOLD"Producer stub protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards Producer stub"
        export PROD_STUB_HTTPX="https"
        export PROD_STUB_PORT=$PROD_STUB_INTERNAL_SECURE_PORT
        export PROD_STUB_LOCAL_PORT=$PROD_STUB_EXTERNAL_SECURE_PORT
@@ -1728,7 +2186,8 @@ start_policy_agent() {
 # args: -
 # (Function for test scripts)
 use_agent_rest_http() {
-       echo -e "Using $BOLD http $EBOLD and $BOLD REST $EBOLD towards the agent"
+       echo -e $BOLD"Agent protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD and $BOLD REST $EBOLD towards the agent"
        export ADAPTER=$RESTBASE
        echo ""
 }
@@ -1737,7 +2196,8 @@ use_agent_rest_http() {
 # args: -
 # (Function for test scripts)
 use_agent_rest_https() {
-       echo -e "Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards the agent"
+       echo -e $BOLD"Agent protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards the agent"
        export ADAPTER=$RESTBASE_SECURE
        echo ""
        return 0
@@ -1747,7 +2207,8 @@ use_agent_rest_https() {
 # args: -
 # (Function for test scripts)
 use_agent_dmaap_http() {
-       echo -e "Using $BOLD http $EBOLD and $BOLD DMAAP $EBOLD towards the agent"
+       echo -e $BOLD"Agent dmaap protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD and $BOLD DMAAP $EBOLD towards the agent"
        export ADAPTER=$DMAAPBASE
        echo ""
        return 0
@@ -1757,7 +2218,8 @@ use_agent_dmaap_http() {
 # args: -
 # (Function for test scripts)
 use_agent_dmaap_https() {
-       echo -e "Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards the agent"
+       echo -e $BOLD"Agent dmaap protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD and $BOLD DMAAP $EBOLD towards the agent"
        export ADAPTER=$DMAAPBASE_SECURE
        echo ""
        return 0
@@ -1767,7 +2229,7 @@ use_agent_dmaap_https() {
 # args: -
 # (Function for test scripts)
 set_agent_debug() {
-       echo -e $BOLD"Setting agent debug"$EBOLD
+       echo -e $BOLD"Setting agent debug logging"$EBOLD
        actuator="/actuator/loggers/org.oransc.policyagent"
        if [[ $POLICY_AGENT_IMAGE = *"onap"* ]]; then
                actuator="/actuator/loggers/org.onap.ccsdk.oran.a1policymanagementservice"
@@ -1787,7 +2249,7 @@ set_agent_debug() {
 # args: -
 # (Function for test scripts)
 set_agent_trace() {
-       echo -e $BOLD"Setting agent trace"$EBOLD
+       echo -e $BOLD"Setting agent trace logging"$EBOLD
        actuator="/actuator/loggers/org.oransc.policyagent"
        if [[ $POLICY_AGENT_IMAGE = *"onap"* ]]; then
                actuator="/actuator/loggers/org.onap.ccsdk.oran.a1policymanagementservice"
@@ -1823,6 +2285,25 @@ use_agent_retries() {
 start_ecs() {
 
        echo -e $BOLD"Starting ECS"$EBOLD
+
+       curdir=$PWD
+       cd $SIM_GROUP
+       cd ecs
+       cd $ECS_HOST_MNT_DIR
+       if [ -d database ]; then
+               if [ "$(ls -A $DIR)" ]; then
+                       echo -e $BOLD" Cleaning files in mounted dir: $PWD/database"$EBOLD
+                       rm -rf database/*  &> /dev/null
+                       if [ $? -ne 0 ]; then
+                               echo -e $RED" Cannot remove database files in: $PWD"$ERED
+                               exit 1
+                       fi
+               fi
+       else
+               echo " No files in mounted dir or dir does not exists"
+       fi
+       cd $curdir
+
        __check_included_image 'ECS'
        if [ $? -eq 1 ]; then
                echo -e $RED"The ECS image has not been checked for this test run due to arg to the test script"$ERED
@@ -1833,11 +2314,30 @@ start_ecs() {
        __start_container ecs NODOCKERARGS $ECS_APP_NAME $ECS_EXTERNAL_PORT "/status" "http"
 }
 
+# Restart ECS
+# args: -
+# (Function for test scripts)
+restart_ecs() {
+       echo -e $BOLD"Re-starting ECS"$EBOLD
+       docker restart $ECS_APP_NAME &> ./tmp/.dockererr
+       if [ $? -ne 0 ]; then
+               __print_err "Could restart $ECS_APP_NAME" $@
+               cat ./tmp/.dockererr
+               ((RES_CONF_FAIL++))
+               return 1
+       fi
+
+       __check_container_start $ECS_APP_NAME $ECS_EXTERNAL_PORT "/status" "http"
+       echo ""
+       return 0
+}
+
 # All calls to ECS will be directed to the ECS REST interface from now on
 # args: -
 # (Function for test scripts)
 use_ecs_rest_http() {
-       echo -e "Using $BOLD http $EBOLD and $BOLD REST $EBOLD towards ECS"
+       echo -e $BOLD"ECS protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD and $BOLD REST $EBOLD towards ECS"
        export ECS_ADAPTER=$ECS_RESTBASE
        echo ""
 }
@@ -1846,7 +2346,8 @@ use_ecs_rest_http() {
 # args: -
 # (Function for test scripts)
 use_ecs_rest_https() {
-       echo -e "Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards ECS"
+       echo -e $BOLD"ECS protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards ECS"
        export ECS_ADAPTER=$ECS_RESTBASE_SECURE
        echo ""
        return 0
@@ -1856,7 +2357,9 @@ use_ecs_rest_https() {
 # args: -
 # (Function for test scripts)
 use_ecs_dmaap_http() {
-       echo -e "Using $BOLD http $EBOLD and $BOLD DMAAP $EBOLD towards ECS"
+       echo -e $BOLD"ECS dmaap protocol setting"$EBOLD
+       echo -e $RED" - NOT SUPPORTED - "$ERED
+       echo -e " Using $BOLD http $EBOLD and $BOLD DMAAP $EBOLD towards ECS"
        export ECS_ADAPTER=$ECS_DMAAPBASE
        echo ""
        return 0
@@ -1866,7 +2369,9 @@ use_ecs_dmaap_http() {
 # args: -
 # (Function for test scripts)
 use_ecs_dmaap_https() {
-       echo -e "Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards ECS"
+       echo -e $BOLD"RICSIM protocol setting"$EBOLD
+       echo -e $RED" - NOT SUPPORTED - "$ERED
+       echo -e " Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards ECS"
        export ECS_ADAPTER=$ECS_DMAAPBASE_SECURE
        echo ""
        return 0
@@ -1876,7 +2381,7 @@ use_ecs_dmaap_https() {
 # args: -
 # (Function for test scripts)
 set_ecs_debug() {
-       echo -e $BOLD"Setting ecs debug"$EBOLD
+       echo -e $BOLD"Setting ecs debug logging"$EBOLD
        curlString="$LOCALHOST$ECS_EXTERNAL_PORT/actuator/loggers/org.oransc.enrichment -X POST  -H Content-Type:application/json -d {\"configuredLevel\":\"debug\"}"
        result=$(__do_curl "$curlString")
        if [ $? -ne 0 ]; then
@@ -1892,7 +2397,7 @@ set_ecs_debug() {
 # args: -
 # (Function for test scripts)
 set_ecs_trace() {
-       echo -e $BOLD"Setting ecs trace"$EBOLD
+       echo -e $BOLD"Setting ecs trace logging"$EBOLD
        curlString="$LOCALHOST$ECS_EXTERNAL_PORT/actuator/loggers/org.oransc.enrichment -X POST  -H Content-Type:application/json -d {\"configuredLevel\":\"trace\"}"
        result=$(__do_curl "$curlString")
        if [ $? -ne 0 ]; then
@@ -1986,7 +2491,7 @@ store_logs() {
        __print_err "need one arg, <file-prefix>" $@
                exit 1
        fi
-       echo -e $BOLD"Storing all container logs using prefix: "$1$EBOLD
+       echo -e $BOLD"Storing all container logs in $TESTLOGS/$ATC using prefix: "$1$EBOLD
 
        docker stats --no-stream > $TESTLOGS/$ATC/$1_docker_stats.log 2>&1
 
@@ -2069,7 +2574,6 @@ __do_curl() {
                        echo "<no-response-from-server>"
                        return 1
                else
-                       echo "X2" >> $HTTPLOG
                        return 0
                fi
        else
@@ -2107,8 +2611,9 @@ __var_test() {
                        checkjsonarraycount=1
                fi
 
-               echo -e $BOLD"TEST(${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5} within ${6} seconds"$EBOLD
+               echo -e $BOLD"TEST $TEST_SEQUENCE_NR (${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5} within ${6} seconds"$EBOLD
                ((RES_TEST++))
+               ((TEST_SEQUENCE_NR++))
                start=$SECONDS
                ctr=0
                for (( ; ; )); do
@@ -2168,8 +2673,9 @@ __var_test() {
                        checkjsonarraycount=1
                fi
 
-               echo -e $BOLD"TEST(${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5}"$EBOLD
+               echo -e $BOLD"TEST $TEST_SEQUENCE_NR (${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5}"$EBOLD
                ((RES_TEST++))
+               ((TEST_SEQUENCE_NR++))
                if [ $checkjsonarraycount -eq 0 ]; then
                        result="$(__do_curl $2$3)"
                        retcode=$?
@@ -2212,22 +2718,6 @@ __var_test() {
 
 ### Generic test cases for varaible checking
 
-# Tests if a variable value in the CR is equal to a target value and and optional timeout.
-# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
-# equal to the target or not.
-# Arg: <variable-name> <target-value> <timeout-in-sec>  - This test waits up to the timeout seconds
-# before setting pass or fail depending on if the variable value becomes equal to the target
-# value or not.
-# (Function for test scripts)
-cr_equal() {
-       if [ $# -eq 2 ] || [ $# -eq 3 ]; then
-               __var_test "CR" "$LOCALHOST$CR_EXTERNAL_PORT/counter/" $1 "=" $2 $3
-       else
-               ((RES_CONF_FAIL++))
-               __print_err "Wrong args to cr_equal, needs two or three args: <sim-param> <target-value> [ timeout ]" $@
-       fi
-}
-
 # Tests if a variable value in the MR stub is equal to a target value and and optional timeout.
 # Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
 # equal to the target or not.